LIBRARY ieee;
USE ieee.std_logic_1164.all;

entity part2 is
	port
	(
		SW	 : in  std_logic_vector(9 downto 0);
		Hex0 : out std_logic_vector(0 to 6);
		Hex1 : out std_logic_vector(0 to 6)
	);
end part2;


architecture behav of part2 is
   signal v, vm9, h0, h1 : std_logic_vector(3 downto 0);
	signal cmp : std_logic;

begin

   v <= SW(3 downto 0);
	
	cmp <= (v(3) AND v(1)) OR (v(3) AND v(2));
	
	
	with v select
	vm9 <= "0000" when "1010",
			 "0001" when "1011",
			 "0010" when "1100",
			 "0011" when "1101",
			 "0100" when "1110",
			 "0101" when "1111",
			 "----" when others ;
	
	with cmp select
	h1 <= "1111" when '0',
	      "0001" when '1';
	
	
	m: entity work.mux4bit2to1
	port map(v, vm9, cmp, h0);
	
    
   D1: entity work.DisplayDigit(behav)
	port map (h1, HEX1);
	
   D2: entity work.DisplayDigit(behav)
	port map (h0, HEX0);
	
	
end behav;