LIBRARY ieee;
USE ieee.std_logic_1164.all;

entity part4 is
	port
	(
		SW	 : in  std_logic_vector(9 downto 0);
		Hex0 : out std_logic_vector(0 to 6);
		Hex1 : out std_logic_vector(0 to 6);
		LEDR : out std_logic_vector(9 downto 0)
	);
end;


architecture behav of part4 is
   signal a,b,s : std_logic_vector(3 downto 0);
	signal c : std_logic_vector(4 downto 0);
   signal vm9, h0, h1 : std_logic_vector(3 downto 0);
	signal cmp : std_logic;

begin

   c(0) <= SW(8);
	a <= SW(3 downto 0);
	b <= SW(7 downto 4);
	LEDR(3 downto 0) <= s;
	LEDR(4) <= c(4);
	LEDR(8 downto 5) <= "0000";
	LEDR(9) <= (a(3) AND a(1)) OR (a(3) AND a(2)) OR (b(3) AND b(1)) OR (b(3) AND b(2));
	
	f1: entity work.FullAdder
	port map(a(0), b(0), c(0), s(0), c(1));
	
	f2: entity work.FullAdder
	port map(a(1), b(1), c(1), s(1), c(2));
	
	f3: entity work.FullAdder
	port map(a(2), b(2), c(2), s(2), c(3));
	
	f4: entity work.FullAdder
	port map(a(3), b(3), c(3), s(3), c(4));
	
	
	
	cmp <= (s(3) AND s(1)) OR (s(3) AND s(2));
	
	
	with std_logic_vector'(c(4),s(3), s(2), s(1), s(0)) select
	vm9 <= "0000" when "01010",
			 "0001" when "01011",
			 "0010" when "01100",
			 "0011" when "01101",
			 "0100" when "01110",
			 "0101" when "01111",
			 "0110" when "10000",
			 "0111" when "10001",
			 "1000" when "10010",
			 "1001" when "10011",
			 "----" when others ;
	

	h1 <= "1111" when ((cmp='0') and (c(4)='0')) else
	      "0001";
			

	m: entity work.mux4bit2to1
	port map(s, vm9, cmp or c(4), h0);
	
    
   D1: entity work.DisplayDigit(behav)
	port map (h1, HEX1);
	
   D2: entity work.DisplayDigit(behav)
	port map (h0, HEX0);
	
	
end behav;