LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_unsigned.all;

entity part5 is
	port
	(
		SW	 : in  std_logic_vector(9 downto 0);
		Hex0 : out std_logic_vector(0 to 6);
		Hex1 : out std_logic_vector(0 to 6);
		Hex3 : out std_logic_vector(0 to 6);
		Hex5 : out std_logic_vector(0 to 6);		
		LEDR : out std_logic_vector(9 downto 0)
	);
end;


architecture behav of part5 is
   signal a,b : std_logic_vector(3 downto 0);
	signal c0, c1, s1 : std_logic;
   signal t0 : std_logic_vector(4 downto 0);
   signal s0, z0 : std_logic_vector(3 downto 0);

begin

   c0 <= SW(8);
	a <= SW(3 downto 0);
	b <= SW(7 downto 4);
	
	LEDR(8 downto 0) <= "000000000";
	LEDR(9) <= (a(3) AND a(1)) OR (a(3) AND a(2)) OR (b(3) AND b(1)) OR (b(3) AND b(2));
	
	t0 <= ('0' & a) + ('0' & b ) + c0;
add:
	process(t0) is 
	begin 
		if (t0 > "01001") then
			z0<= "0110"; -- add 6 instead of subtract 10.
			c1<='1';
		else 
			z0<= "0000";
			c1<='0';
		end if;
		
	end process; 
	s0 <= t0(3 downto 0)+z0;
	s1 <= c1;

	
   D1: entity work.DisplayDigit(behav)
	port map (s0, HEX0);
	
   D2: entity work.DisplayDigit(behav)
	port map ("000"&s1, HEX1);	
	    
   D3: entity work.DisplayDigit(behav)
	port map (a, HEX3);
	
   D5: entity work.DisplayDigit(behav)
	port map (b, HEX5);
	
	
end behav;