LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_unsigned.all;

entity part6 is
	port
	(
		SW	 : in  std_logic_vector(5 downto 0);
		Hex0 : out std_logic_vector(0 to 6);
		Hex1 : out std_logic_vector(0 to 6);		
		LEDR : out std_logic_vector(9 downto 0)
	);
end;


architecture behav of part6 is
   signal a : std_logic_vector(5 downto 0);
   signal s0: std_logic_vector(3 downto 0);
   signal s1: std_logic_vector(2 downto 0);
begin

   LEDR(5 downto 0) <= SW;
	LEDR(9 downto 6) <= "0000";
	a <= SW;

add:
	process(a) is 
	begin 
		if (a > "111011") then
			s0<= a(3 downto 0)+"0100"; -- add 4 instead of subtract 60.
			s1<="110";
		elsif (a > "110001") then 
			s0<= a(3 downto 0)+"1110"; -- add 14 instead of subtract 50.
			s1<="101";
		elsif (a > "100111") then 
			s0<= a(3 downto 0)+"1000"; -- add first four bit of 24 instead of subtract 40.
			s1<="100";	
		elsif (a > "011101") then
			s0<= a(3 downto 0)+"0010"; -- add first four bit of 34 instead of subtract 30.
			s1<="011";
		elsif (a > "010011") then 
			s0<= a(3 downto 0)+"1100"; -- add first four bit of 44 instead of subtract 20.
			s1<="010";
		elsif (a > "001001") then 
			s0<= a(3 downto 0)+"0110"; -- add first four bit of 54 instead of subtract 10.
			s1<="001";
		else
		   s0<= a(3 downto 0);
			s1<= "000";
		end if;
		
	end process; 
	
   D1: entity work.DisplayDigit(behav)
	port map (s0, HEX0);
	
   D2: entity work.DisplayDigit(behav)
	port map ("0"&s1, HEX1);	
	    	
	
end behav;